package net.locusworks.worldcities.entities;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class City {
  
  private long id;
  private String cityName;
  private String countryName;
  private String iso2;
  private String iso3;
  private Location location;
  
  public City(long id, String cityName, String countryName, Location location) {
    this(id, cityName, countryName, null, null, location);
  }
  
  /**
   * @param id
   * @param cityName
   * @param countryName
   * @param iso2
   * @param iso3
   * @param location
   */
  public City(long id, String cityName, String countryName, String iso2, String iso3, Location location) {
    this.id = id;
    this.cityName = cityName;
    this.countryName = countryName;
    this.iso2 = iso2;
    this.iso3 = iso3;
    this.location = location;
  }

  /**
   * @return the id
   */
  public long getId() {
    return id;
  }

  /**
   * @param id the id to set
   */
  public void setId(long id) {
    this.id = id;
  }

  /**
   * @return the cityName
   */
  public String getCityName() {
    return cityName;
  }

  /**
   * @param cityName the cityName to set
   */
  public void setCityName(String cityName) {
    this.cityName = cityName;
  }

  /**
   * @return the countryName
   */
  public String getCountryName() {
    return countryName;
  }

  /**
   * @param countryName the countryName to set
   */
  public void setCountryName(String countryName) {
    this.countryName = countryName;
  }

  /**
   * @return the iso2
   */
  public String getIso2() {
    return iso2;
  }

  /**
   * @param iso2 the iso2 to set
   */
  public void setIso2(String iso2) {
    this.iso2 = iso2;
  }

  /**
   * @return the iso3
   */
  public String getIso3() {
    return iso3;
  }

  /**
   * @param iso3 the iso3 to set
   */
  public void setIso3(String iso3) {
    this.iso3 = iso3;
  }

  /**
   * @return the location
   */
  public Location getLocation() {
    return location;
  }

  /**
   * @param location the location to set
   */
  public void setLocation(Location location) {
    this.location = location;
  }
  
  
  @Override
  public String toString() {
    ObjectMapper mapper = new ObjectMapper();
    try {
      return mapper.writerWithDefaultPrettyPrinter().writeValueAsString(this);
    } catch (JsonProcessingException e) {
      throw new IllegalArgumentException(e);
    }
  }
  

}
