package net.locusworks.worldcities.entities;

public class Location {
  
  private float latitude;
  private float longitude;
  
  public Location(float latitude, float longitude) {
    this.latitude = latitude;
    this.longitude = longitude;
  }
  
  public float getLatitude() {
    return this.latitude;
  }
  
  public float getLongitude() {
    return this.longitude;
  }
  
  public String toDMS() {
    String lat = toDegreesMinutesAndSeconds(this.latitude);
    String latCardinal = this.latitude >= 0 ? "N" : "S";

    String lng = toDegreesMinutesAndSeconds(this.longitude);
    String lngiCardinal = this.longitude >= 0 ? "E" : "W";

    return String.format("%s%s%s%s", lat, latCardinal, lng, lngiCardinal);
  }
  
  private String toDegreesMinutesAndSeconds(float coordinate) {
    float absolute = Math.abs(coordinate);
    double degrees = Math.floor(absolute);
    double minutesNotTruncated = (absolute - degrees) * 60;
    double minutes = Math.floor(minutesNotTruncated);
    double seconds = Math.floor((minutesNotTruncated - minutes) * 60);

    return String.format("%2s%2s%s", (long)degrees, (long)minutes, seconds);
  }

}
