package net.locusworks.worldcities.tests;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

import org.junit.jupiter.api.Test;

import net.locusworks.worldcities.WorldCities;
import net.locusworks.worldcities.entities.City;

class WorldCitiesTest {

  @Test
  void testFindByCityName() {
    City city = WorldCities.findByCityName("Cheremoshna");
    assertNotNull(city);
    assertEquals(city.getCityName(), "Cheremoshna");
  }

  @Test
  void testFindByCityNameLike() {
    List<City> cities = WorldCities.findByCityNameLike("Cher");
    assertTrue(cities.size() == 33);
  }

  @Test
  void testFindCitiesByCountry() throws IOException {
    List<City> cities = WorldCities.findCitiesByCountry("Ukraine");
    assertTrue(cities.size() == 51);
    
    Path file = Paths.get("ukraine.txt");
    
    try(BufferedWriter bos = new BufferedWriter(Files.newBufferedWriter(file))) {
      for (City c : cities) {
        bos.write(String.format("%s%n", c));
        System.out.println(c.getLocation().toDMS());
      }
    }
    
  }

}
